/*

    File: Landscape.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined LANDSCAPE_H
#define LANDSCAPE_H

//#define CALC_EDGE_COST
#define LIGHTMAP_TEXTURE
//#define COLORMAP_USE_COST

typedef struct {
	float	height;
#ifndef LIGHTMAP_TEXTURE
	long	color;
#endif
#ifdef CALC_EDGE_COST
	float	cost_u, cost_v, cost_uv;	//the cost of the three edges
#endif
} ls_vertex_t;

bool landscapeInit(void);
void landscapeUpdate(void);
void landscapeShutdown(void);

#endif